PersistenceExceptionTranslationInterceptor (Spring Framework 3.2.1.RELEASE API)
Date: 2013-01-24

org.springframework.dao.support

## Class PersistenceExceptionTranslationInterceptor

- java.lang.Object
- - org.springframework.dao.support.PersistenceExceptionTranslationInterceptor

- All Implemented Interfaces:
    Advice, Interceptor, MethodInterceptor, Aware, BeanFactoryAware, InitializingBean

      public class PersistenceExceptionTranslationInterceptor
      extends Object
      implements MethodInterceptor, BeanFactoryAware, InitializingBean

  AOP Alliance MethodInterceptor that provides persistence exception translation based on a given PersistenceExceptionTranslator.

  Delegates to the given `PersistenceExceptionTranslator` to translate a RuntimeException thrown into Spring's DataAccessException hierarchy (if appropriate). If the RuntimeException in question is declared on the target method, it is always propagated as-is (with no translation applied).

  Since:
    2.0
  Author:
    Rod Johnson, Juergen Hoeller
  See Also:
    `PersistenceExceptionTranslator`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PersistenceExceptionTranslationInterceptor()` Create a new PersistenceExceptionTranslationInterceptor.
    `PersistenceExceptionTranslationInterceptor(ListableBeanFactory beanFactory)` Create a new PersistenceExceptionTranslationInterceptor, autodetecting PersistenceExceptionTranslators in the given BeanFactory.
    `PersistenceExceptionTranslationInterceptor(PersistenceExceptionTranslator persistenceExceptionTranslator)` Create a new PersistenceExceptionTranslationInterceptor for the given PersistenceExceptionTranslator.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `afterPropertiesSet()` Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).
    `protected PersistenceExceptionTranslator` | `detectPersistenceExceptionTranslators(ListableBeanFactory beanFactory)` Detect all PersistenceExceptionTranslators in the given BeanFactory.
    `Object` | `invoke(MethodInvocation mi)`
    `void` | `setAlwaysTranslate(boolean alwaysTranslate)` Specify whether to always translate the exception ("true"), or whether throw the raw exception when declared, i.e.
    `void` | `setBeanFactory(BeanFactory beanFactory)` Callback that supplies the owning factory to a bean instance.
    `void` | `setPersistenceExceptionTranslator(PersistenceExceptionTranslator pet)` Specify the PersistenceExceptionTranslator to use.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PersistenceExceptionTranslationInterceptor

          public PersistenceExceptionTranslationInterceptor()

      Create a new PersistenceExceptionTranslationInterceptor. Needs to be configured with a PersistenceExceptionTranslator afterwards.
      See Also:
        `setPersistenceExceptionTranslator(org.springframework.dao.support.PersistenceExceptionTranslator)`

    - #### PersistenceExceptionTranslationInterceptor

          public PersistenceExceptionTranslationInterceptor(PersistenceExceptionTranslator persistenceExceptionTranslator)

      Create a new PersistenceExceptionTranslationInterceptor for the given PersistenceExceptionTranslator.
      Parameters:
        `persistenceExceptionTranslator` - the PersistenceExceptionTranslator to use

    - #### PersistenceExceptionTranslationInterceptor

          public PersistenceExceptionTranslationInterceptor(ListableBeanFactory beanFactory)

      Create a new PersistenceExceptionTranslationInterceptor, autodetecting PersistenceExceptionTranslators in the given BeanFactory.
      Parameters:
        `beanFactory` - the ListableBeanFactory to obtaining all PersistenceExceptionTranslators from

  - ### Method Detail

    - #### setPersistenceExceptionTranslator

          public void setPersistenceExceptionTranslator(PersistenceExceptionTranslator pet)

      Specify the PersistenceExceptionTranslator to use.

      Default is to autodetect all PersistenceExceptionTranslators in the containing BeanFactory, using them in a chain.

      See Also:
        `detectPersistenceExceptionTranslators(org.springframework.beans.factory.ListableBeanFactory)`

    - #### setAlwaysTranslate

          public void setAlwaysTranslate(boolean alwaysTranslate)

      Specify whether to always translate the exception ("true"), or whether throw the raw exception when declared, i.e. when the originating method signature's exception declarations allow for the raw exception to be thrown ("false").

      Default is "false". Switch this flag to "true" in order to always translate applicable exceptions, independent from the originating method signature.

      Note that the originating method does not have to declare the specific exception. Any base class will do as well, even `throws Exception`: As long as the originating method does explicitly declare compatible exceptions, the raw exception will be rethrown. If you would like to avoid throwing raw exceptions in any case, switch this flag to "true".

    - #### setBeanFactory

          public void setBeanFactory(BeanFactory beanFactory)
                              throws BeansException

      Description copied from interface: `BeanFactoryAware`
      Callback that supplies the owning factory to a bean instance.

      Invoked after the population of normal bean properties but before an initialization callback such as `InitializingBean.afterPropertiesSet()` or a custom init-method.

      Specified by:
        `setBeanFactory` in interface `BeanFactoryAware`
      Parameters:
        `beanFactory` - owning BeanFactory (never `null`). The bean can immediately call methods on the factory.
      Throws:
        `BeansException` - in case of initialization errors
      See Also:
        `BeanInitializationException`

    - #### afterPropertiesSet

          public void afterPropertiesSet()

      Description copied from interface: `InitializingBean`
      Invoked by a BeanFactory after it has set all bean properties supplied (and satisfied BeanFactoryAware and ApplicationContextAware).

      This method allows the bean instance to perform initialization only possible when all bean properties have been set and to throw an exception in the event of misconfiguration.

      Specified by:
        `afterPropertiesSet` in interface `InitializingBean`

    - #### detectPersistenceExceptionTranslators

          protected PersistenceExceptionTranslator detectPersistenceExceptionTranslators(ListableBeanFactory beanFactory)

      Detect all PersistenceExceptionTranslators in the given BeanFactory.
      Parameters:
        `beanFactory` - the ListableBeanFactory to obtaining all PersistenceExceptionTranslators from
      Returns:
        a chained PersistenceExceptionTranslator, combining all PersistenceExceptionTranslators found in the factory
      See Also:
        `ChainedPersistenceExceptionTranslator`

    - #### invoke

          public Object invoke(MethodInvocation mi)
                        throws Throwable

      Specified by:
        `invoke` in interface `MethodInterceptor`
      Throws:
        `Throwable`